<?php

namespace App\Models;

use App\Http\Helpers\Hasher;

use Illuminate\Database\Eloquent\Model;
use Carbon\Carbon;

class EntitySignature extends Model
{
    protected $table = 'entity_signatures';

    protected $appends = ['hash_id', 'entity_list'];

    public function entity()
    {
        return $this->belongsTo('App\Models\Entity', 'entity_id');
    }

    public function getHashIdAttribute()
    {
        return Hasher::encode('entity_signatures', $this->id);
    }

    public function getEntityListAttribute()
    {
        return $this->entity()->get()->makeHidden(['entity_signature_list']);
    }

    public function getUpdatedAtAttribute($date) 
    {
        return $date ? Carbon::parse($date)->timezone('Asia/Kuala_Lumpur')->format('Y-m-d') : '';
    }

    public function getCreatedAtAttribute($date) 
    {
        return $date ? Carbon::parse($date)->timezone('Asia/Kuala_Lumpur')->format('Y-m-d') : '';
    }
}
